// IBM Confidential OCO Source Material
// 5724-J34 (C) COPYRIGHT International Business Machines Corp. 2013
// The source code for this program is not published or otherwise divested
// of its trade secrets, irrespective of what has been deposited with the
// U.S. Copyright Office.

def getServerChoices(filters, owner = false) {
    try
    {
        def originalCount = request.params.count[].toInteger();
        
        filters.count = originalCount;
        
        def relatedType = request.params.relatedType[];
        def relatedID = request.params.relatedID[];
        
        def serverResources = getJoinedResources("servers", [:], true, "domains", 1);
    
        def results = [];
   		def existingServers = [];
   		serverResources.each { serverResource ->
   			existingServers << serverResource.alias;
        }

   		def servers = getResources( 'servers', filters, false,  ["id", "alias", "name", "listenerport", "jmxport"])
        
        // need to manually remove all system users
        _servers = [];
        servers.each { server ->
            if ( !existingServers.contains(server.alias)) {
                server.overrideListViewLabel = "alias";
                _servers << server;
            }
        }
        
        results += _servers;

        request.view = com.ibm.websphere.rest.RenderUtils.getRequestedView();
        request.json.output = results;
        render();
    }
    
    catch (Throwable t)
    {
        return com.ibm.websphere.rest.RenderUtils.renderError(500, 'RM08000', t);
    }
}

def createServerChoice(serverChoice, owner = false) {
	return com.ibm.websphere.rest.RenderUtils.renderError(501);
}

def deleteServerChoice(id) {
	return com.ibm.websphere.rest.RenderUtils.renderError(501);
}

def getServerChoice(id) {
	return com.ibm.websphere.rest.RenderUtils.renderError(501);
}

def updateServerChoice(serverChoices) {
	return com.ibm.websphere.rest.RenderUtils.renderError(501);
}
