/*
Licensed Materials - Property of IBM
IBM WebSphere CloudBurst Appliance (9235-72X)
Copyright IBM Corporation 2009. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import zero.json.Json;

import com.ibm.websphere.rainmaker.auditing.AuditDataHelper;
import com.ibm.websphere.rainmaker.logging.MessageUtils;
import com.ibm.websphere.rest.RESTUtils;
import com.ibm.websphere.users.Permissions;
import com.ibm.websphere.users.Users;
import com.ibm.ws.xsa.common.GridUtilsConstants;
import groovy.rainmaker.constants.Action;

def onList()
{
	if (!RESTUtils.authorized())
        return com.ibm.websphere.rest.RenderUtils.renderError(403, 'RM08008');

	request.view = com.ibm.websphere.rest.RenderUtils.getRequestedView();
    
    request.json.output = zget(config.rainmaker.defaultPersistentZone[] + GridUtilsConstants.ADMIN_ACCESS_PATH, true );
    render();
	
}
def onPutCollection()
{
	if (!RESTUtils.authorized())
        return com.ibm.websphere.rest.RenderUtils.renderError(403, 'RM08008');
    
    // Do not allow non root admin users to make changes -- make a new message!
    def user = zget("/request/subject/remoteUser");  
	def map = Users.getUserByName(user);
	if (map == null || (1 != map.id && 2 != map.id)) {
		return com.ibm.websphere.rest.RenderUtils.renderError(403, 'RM08099');
	}

    def adminAccess = null;
    
    try
    {
        def decoded = Json.decode(request.input[]);
        adminAccess = decoded.toBoolean();
    }
    
    catch (Throwable t)
    {
        return com.ibm.websphere.rest.RenderUtils.renderError(400, 'RM08002', t);
    }
    
	if(adminAccess){
      	zput(config.rainmaker.defaultPersistentZone[] + GridUtilsConstants.ADMIN_ACCESS_PATH, true );
       	logger.WARNING { MessageUtils.message('RM08097', []) };
       	AuditDataHelper.audit(Action.UPDATE, "adminAccess" ,
	        MessageUtils.message('RM08097', []));
    }
    else{
       	zput(config.rainmaker.defaultPersistentZone[] + GridUtilsConstants.ADMIN_ACCESS_PATH, false );
       	logger.WARNING { MessageUtils.message('RM08098', []) };
       	AuditDataHelper.audit(Action.UPDATE, "adminAccess" ,
	        MessageUtils.message('RM08098', []));
    }

    request.status = 204;
        
}
