/*
Licensed Materials - Property of IBM
IBM WebSphere CloudBurst Appliance (9235-72X)
Copyright IBM Corporation 2010. All Rights Reserved.
US Government Users Restricted Rights - Use, duplication or disclosure
restricted by GSA ADP Schedule Contract with IBM Corp.
*/

import com.ibm.ws.xsa.common.Utility;
import java.lang.reflect.Method;

def getSsls(filters, owner = false){
    if (Utility.isAppliance()) {
	    return com.ibm.ws.xsa.collectives.ssl.resources.Ssls.getSsl(filters, owner);
    }
	
    //
    // Calling from XS console. Use reflection. Let RESTUtils handle and log the exception.
    //
    Class[] paramTypes = [ Object.class, Object.class ];
    Object[] params = [ filters, owner ];

    Class<?> ssls = Class.forName("com.ibm.ws.xs.app.Ssls");
    Method method = ssls.getDeclaredMethod("getSsl", paramTypes);
    return method.invoke(null, params);
}

def createSsl(resource, id=null) {
    if (Utility.isAppliance()) {
	    return com.ibm.ws.xsa.collectives.ssl.resources.Ssls.createSsl(resource, id);
    }
	
    //
    // Calling from XS console. Use reflection. Let RESTUtils handle and log the exception.
    //
    Class[] paramTypes = [ java.util.Map.class, Integer.class ];
    Object[] params = [ resource, id ];

    Class<?> ssls = Class.forName("com.ibm.ws.xs.app.Ssls");
    Method method = ssls.getDeclaredMethod("createSsl", paramTypes);
    return method.invoke(null, params);
}

def updateSsl(resource) {
    if (Utility.isAppliance()) {
        return com.ibm.ws.xsa.collectives.ssl.resources.Ssls.updateSsl(resource);
    }
    
    //
    // Calling from XS console. Use reflection. Let RESTUtils handle and log the exception.
    //
    Class[] paramTypes = [ java.util.Map.class ];
    Object[] params = [ resource ];

    Class<?> ssls = Class.forName("com.ibm.ws.xs.app.Ssls");
    Method method = ssls.getDeclaredMethod("updateSsl", paramTypes);
    return method.invoke(null, params);
}
