//Licensed Materials - Property of IBM
//IBM WebSphere DataPower XC10 Appliance (7199-92X).
//Copyright IBM Corporation 2013. All Rights Reserved.
//US Government Users Restricted Rights - Use, duplication or disclosure
//restricted by GSA ADP Schedule Contract with IBM Corp.

dojo.provide("xsa.healthcenter.HealthCenterLayout");

dojo.require("dojo.string");
dojo.require("dojo.data.ItemFileReadStore");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.layout.TabContainer");
dojo.require("dijit.layout.BorderContainer");
dojo.require("dijit.Tree");
dojo.require("dijit.Menu");
dojo.require("dijit.PopupMenuItem");
dojo.require("dijit.MenuSeparator");
dojo.require("dijit.Dialog");
dojo.require("dijit.form.TextBox");
dojo.require("dijit.form.ValidationTextBox");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.FilteringSelect");
dojo.require("dojo.i18n");

dojo.require("xsa.healthcenter.HealthCenter");

dojo.requireLocalization("xsa.healthcenter", "xsa_messages");

dojo.declare("xsa.healthcenter.HealthCenterLayout", [dijit._Widget, dijit._Templated],{
	// summary:
	//		This widget is a composite widget for containing a tree of 
	//		chartable statistics and a tab container for containing the generated
	//		charts.
	
	xsa_messages : null,
	
	// templateString: String
	//		The string to use for the template of this widget.
	templateString: dojo.cache("xsa", "healthcenter/templates/HealthCenterLayoutTemplate.html"),

	// widgetsInTemplate: Boolean
	//		If true, the template as widgets in it.
	widgetsInTemplate: true,

	// _borderContainer: [private] Object
	//		The borderContainer widget used to house all the tree/chart stuff.
	//_borderContainer: null,
	
	// titleText: [public] String
	//		NLS message to display as the title of the panel.
	titleText: "",

	postMixInProperties: function(){
		// sunnary:
		//		Function to mixin translations, etc.
		this.inherited(arguments);
	},

	constructor: function(kwArgs) {
		this.xsa_messages = dojo.i18n.getLocalization("xsa.healthcenter", "xsa_messages");
		this.titleText = this.xsa_messages.healthCenter;
	},
	
	startup: function(){
		// summary:
		//		Over-ridden startup function for the widget.
		var spArgs = {
			//link: this.link	
		};

		this.healthcenter = new xsa.healthcenter.HealthCenter(spArgs, this._detailsNode);
		this.inherited(arguments);
	},

	resize: function(dim){
		// summary:
		//		Resize over-ride to allow calling of child widget resize so that
		//		the widget scales properly in a container.
		// dim:
		//		The dimensions object to process.
		if(dim){
			dojo.contentBox(this.domNode, dim);
		}

		var myDims = dojo.contentBox(this.domNode);
		
		// Internal function usage, may not port (but unlikely to change);
		// Remove any internal padding/margins and use that to set the size of the
		// contained border container.
		var pads = dojo._getPadBorderExtents(this.domNode);
		var margins = dojo._getMarginExtents(this.domNode);
		myDims.h -= (pads.h + margins.h);
		myDims.w -= (pads.w + margins.w);
		//this._borderContainer.resize(myDims);

		this.inherited(arguments);
	},

	destroy: function(){
		// summary:
		//		Over-ridden destroy to handle internal cleanup.
		//if(this._borderContainer) this._borderContainer.destroyRecursive();
		this.inherited(arguments);
	}
});